#!/usr/bin/env pike

GDK.Pixbuf pixbuf;
array(GTK.TextChildAnchor) ta;

void create_tags(GTK.TextBuffer buffer) {
  buffer->create_tag("heading",([ "weight": GTK.PANGO_WEIGHT_BOLD,
				   "size": 15*GTK.PANGO_SCALE ]) );
  buffer->create_tag("italic",([ "style": GTK.PANGO_STYLE_ITALIC ]) );
  buffer->create_tag("bold",([ "weight": GTK.PANGO_WEIGHT_BOLD ]) );
  buffer->create_tag("big",([ "size": 20*GTK.PANGO_SCALE ]) );
  buffer->create_tag("xx-small",([ "scale": GTK.PANGO_SCALE_XX_SMALL ]) );
  buffer->create_tag("x-large",([ "scale": GTK.PANGO_SCALE_X_LARGE ]) );
  buffer->create_tag("monospace",([ "family": "monospace" ]) );
  buffer->create_tag("blue_foreground",([ "foreground": "blue" ]) );
  buffer->create_tag("red_background",([ "background": "red" ]) );
  buffer->create_tag("big_gap_before_line",([ "pixels-above-lines": 30 ]) );
  buffer->create_tag("big_gap_after_line",([ "pixels-below-lines": 30 ]) );
  buffer->create_tag("double_spaced_line",([ "pixels-inside-wrap": 10 ]) );
  buffer->create_tag("not_editable",([ "editable": 0 ]) );
  buffer->create_tag("word_wrap",([ "wrap-mode": GTK.WRAP_WORD ]) );
  buffer->create_tag("char_wrap",([ "wrap-mode": GTK.WRAP_CHAR ]) );
  buffer->create_tag("no_wrap",([ "wrap-mode": GTK.WRAP_NONE ]) );
  buffer->create_tag("center",([ "justification": GTK.JUSTIFY_CENTER ]) );
  buffer->create_tag("right_justify",([ "justification": GTK.JUSTIFY_RIGHT ]) );
  buffer->create_tag("wide_margins",([ "left-margin": 50, "right-margin": 50 ]) );
  buffer->create_tag("strikethrough",([ "strikethrough": 1 ]) );
  buffer->create_tag("underline",([ "underline": GTK.PANGO_UNDERLINE_SINGLE ]) );
  buffer->create_tag("double_underline",([ "underline": GTK.PANGO_UNDERLINE_DOUBLE ]) );
  buffer->create_tag("superscript",([ "rise": 10*GTK.PANGO_SCALE,
				      "size": 8*GTK.PANGO_SCALE ]) );
  buffer->create_tag("subscript",([ "rise": -10*GTK.PANGO_SCALE,
				    "size": 8*GTK.PANGO_SCALE ]) );
  buffer->create_tag("rtl_quote",([ "wrap-mode": GTK.WRAP_WORD,
				    "direction": GTK.TEXT_DIR_RTL,
				    "indent": 30,
				    "left-margin": 20,
				    "right-margin": 20 ]) );

  GDK.Bitmap stipple=GDK.Bitmap(2,2,"\02\01");
  buffer->create_tag("background_stipple",([ "background-stipple": stipple ]) );
  buffer->create_tag("foreground_stipple",([ "foreground-stipple": stipple ]) );

  pixbuf=GDK.Pixbuf();
  pixbuf->set_from_file("gtk-logo-rgb.gif");
  pixbuf=pixbuf->scale_simple(32,32,GDK.INTERP_BILINEAR);
}

void insert_text(GTK.TextBuffer buffer) {
  object iter=buffer->get_iter_at_offset(0);
  buffer->insert(iter,"The text widget can display text with all kinds of nifty attributes. It also supports multiple views of the same buffer; this demo is showing the same buffer in two places.\n\n",-1);
  buffer->insert_with_tags_by_name(iter,"Font styles.",-1,({ "heading" }) );
  buffer->insert(iter,"For example, you can have ",-1);
  buffer->insert_with_tags_by_name(iter,"italic",-1,({ "italic" }) );
  buffer->insert(iter,", ",-1);
  buffer->insert_with_tags_by_name(iter,"bold",-1,({ "bold" }) );
  buffer->insert(iter,", or ",-1);
  buffer->insert_with_tags_by_name(iter,"monospace (typewriter)",-1,({ "monospace" }) );
  buffer->insert(iter,", or ",-1);
  buffer->insert_with_tags_by_name(iter,"big",-1,({ "big" }) );
  buffer->insert(iter," text.",-1);
  buffer->insert(iter,"It's best not to hardcode specific text sizes; you can use relatives sizes as with CSS, such as ",-1);
  buffer->insert_with_tags_by_name(iter,"xx-small",-1,({ "xx-small" }) );
  buffer->insert(iter," or ",-1);
  buffer->insert_with_tags_by_name(iter,"x-large",-1,({ "x-large" }) );
  buffer->insert(iter," to ensure that your program properly adapts if the user changes the default font size.\n\n",-1);
  buffer->insert_with_tags_by_name(iter,"Colors. ",-1,({ "heading" }) );
  buffer->insert(iter,"Colors such as ",-1);
  buffer->insert_with_tags_by_name(iter,"a blue foreground",-1,({ "blue_foreground" }) );
  buffer->insert(iter," or ",-1);
  buffer->insert_with_tags_by_name(iter,"a red background",-1,({ "red_background" }) );
  buffer->insert(iter," or even ",-1);
  buffer->insert_with_tags_by_name(iter,"a stippled red background",-1,({ "red_background", "background_stipple" }) );
  buffer->insert(iter," or ",-1);
  buffer->insert_with_tags_by_name(iter,"a stippled blue foreground on solid red background",
	-1,({ "blue_foreground","red_background","foreground_stipple" }) );
  buffer->insert(iter," (select that to read it) can be used.\n\n",-1);
  buffer->insert_with_tags_by_name(iter,"Underline, strikethrough, and rise.",-1,({ "heading" }) );
  buffer->insert_with_tags_by_name(iter,"Strikethrough",-1,({ "strikethrough" }) );
  buffer->insert(iter,", ",-1);
  buffer->insert_with_tags_by_name(iter,"underline",-1,({ "underline" }) );
  buffer->insert(iter,", ",-1);
  buffer->insert_with_tags_by_name(iter,"double underline",-1,({ "double_underline" }) );
  buffer->insert(iter,", ",-1);
  buffer->insert_with_tags_by_name(iter,"superscript",-1,({ "superscript" }) );
  buffer->insert(iter,", and ",-1);
  buffer->insert_with_tags_by_name(iter,"subscript",-1,({ "subscript" }) );
  buffer->insert(iter," are all supported.\n\n",-1);
  buffer->insert_with_tags_by_name(iter,"Images. ",-1,({ "heading" }) );
  buffer->insert(iter,"The buffer can have images in it: ",-1);
  buffer->insert_pixbuf(iter,pixbuf);
  buffer->insert_pixbuf(iter,pixbuf);
  buffer->insert_pixbuf(iter,pixbuf);
  buffer->insert(iter," for example.\n\n",-1);
  buffer->insert_with_tags_by_name(iter,"Spacing. ",-1,({ "heading" }) );
  buffer->insert(iter,"You can adjust the amount of space before each line.\n",-1);
  buffer->insert_with_tags_by_name(iter,"This line has a whole lot of space before it.\n",-1,({ "big_gap_before_line","wide_margins" }) );
  buffer->insert_with_tags_by_name(iter,"You can also adjust the amount of space after each line; this line has a whole lot of space after it.\n",
		-1,({ "big_gap_after_line","wide_margins" }) );
  buffer->insert_with_tags_by_name(iter,"You can also adjust the amount of space"
	" between wrapped lines; this line has extra space between each wrapped"
	" line in the same paragraph.  To show off wrapping, some filler text:"
	"  the quick brown fox jumped over the lazy dog.  Blah blah blah blah"
	" blah blah blah blah blah blah blah blah\n",-1,({ "double_spaced_line",
	"wide_margins" }) );
  buffer->insert(iter,"Also note that those lines have extra-wide margins.\n\n",-1);
  buffer->insert_with_tags_by_name(iter,"Editability. ",-1,({ "heading" }) );
  buffer->insert_with_tags_by_name(iter,"This line is 'locked down' and can't"
	" be edited by the user - just try it!  You can't delete this line.\n\n",
	-1,({ "not_editable" }) );
  buffer->insert_with_tags_by_name(iter,"Wrapping. ",-1,({ "heading" }) );
  buffer->insert(iter,"This line (and most of the others in this buffer) is"
	" word-wrapped, using the proper Unicode algorithm.  Word wrap should"
	" work in all scripts and languages that GTK+ supports.  Let's make"
	" this a long paragraph to demonstrate: blah blah blah blah blah blah"
	" blah blah blah blah blah blah blah blah blah blah blah blah blah",
	-1);
  buffer->insert_with_tags_by_name(iter,"This line has character-based wrapping"
	", and can wrap between any two character glyps.  Let's make this a"
	" long paragraph to demonstrate: blah blah blah blah blah blah blah"
	" blah blah blah blah blah blah blah blah blah blah blah blah blah",
	-1,({ "char_wrap" }) );
  buffer->insert_with_tags_by_name(iter,"This line has all wrapping turned off"
	", so it makes the horizontal scrollbar appear.\n\n\n",-1,
	({ "no_wrap" }) );
  buffer->insert_with_tags_by_name(iter,"Justification. ",-1,({ "heading" }) );
  buffer->insert_with_tags_by_name(iter,"\nThis line has center justification.\n",-1,({ "center" }) );
  buffer->insert_with_tags_by_name(iter,"This line has right justification.\n",-1,({ "right_justify" }) );
  buffer->insert_with_tags_by_name(iter,"\nThis line has big wide margins.  Text"
	" text text text text text text text text text text text text text"
	" text text text text text text text text text text text text text.\n",
	-1,({ "wide_margins" }) );
  buffer->insert_with_tags_by_name(iter,"Internationalization. ",-1,({ "heading" }) );
  string s= "You can put all sorts of Unicode text in the buffer.\n\n"
	"German (Deutsch S\303\274d) Gr\303\274\303\237 Gott\n"
	"Greek (\316\225\316\273\316\273\316\267\316\275\316\271\316\272\316\254)"
	" \316\223\316\265\316\271\316\254 \317\203\316\261\317\202\n"
	"Hebrew      \327\251\327\234\327\225\327\235\n"
	"Japanese (\346\227\245\346\234\254\350\252\236)\n\n"
	"The widget properly handles bidirectional text, word wrapping, DOS/UNIX"
	"/Unicode paragraph separators, grapheme boundaries, and so on using"
	" the Pango internationalization framework.\n";
  buffer->insert(iter,s,-1);
  buffer->insert(iter,"Here's a word-wrapped quote in a right-to-left language:\n",-1);
  s="\331\210\331\202\330\257 \330\250\330\257\330\243 "
	"\330\253\331\204\330\247\330\253 \331\205\331\206"
	"\330\243\331\203\330\253\330\261 \330\247\331\204\331\205\330\244\330"
	"\263\330\263\330\247\330\252 \330\252\331\202\330\257\331\205\330\247 "
	"\331\201\331\212 \330\264\330\250\331\203\330\251 \330\247\331\203\330"
	"\263\331\212\331\210\331\206 \330\250\330\261\330\247\331\205\330\254"
	"\331\207\330\247 \331\203\331\205\331\206\330\270\331\205\330\247\330"
	"\252 \331\204\330\247 \330\252\330\263\330\271\331\211 \331\204\331"
	"\204\330\261\330\250\330\255\330\214 \330\253\331\205 \330\252\330"
	"\255\331\210\331\204\330\252 \331\201\331\212 \330\247\331\204\330"
	"\263\331\206\331\210\330\247\330\252 \330\247\331\204\330\256\331\205"
	"\330\263 \330\247\331\204\331\205\330\247\330\266\331\212\330\251 "
	"\330\245\331\204\331\211 \331\205\330\244\330\263\330\263\330\247\330"
	"\252 \331\205\330\247\331\204\331\212\330\251 \331\205\331\206\330"
	"\270\331\205\330\251\330\214 \331\210\330\250\330\247\330\252\330"
	"\252 \330\254\330\262\330\241\330\247 \331\205\331\206 \330\247\331"
	"\204\331\206\330\270\330\247\331\205 \330\247\331\204\331\205\330\247"
	"\331\204\331\212 \331\201\331\212 \330\250\331\204\330\257\330\247"
	"\331\206\331\207\330\247\330\214 \331\210\331\204\331\203\331\206\331"
	"\207\330\247 \330\252\330\252\330\256\330\265\330\265 \331\201\331"
	"\212 \330\256\330\257\331\205\330\251 \331\202\330\267\330\247\330"
	"\271 \330\247\331\204\331\205\330\264\330\261\331\210\330\271\330\247"
	"\330\252 \330\247\331\204\330\265\330\272\331\212\330\261\330\251. "
	"\331\210\330\243\330\255\330\257 \330\243\331\203\330\253\330\261 "
	"\331\207\330\260\331\207 \330\247\331\204\331\205\330\244\330\263\330"
	"\263\330\247\330\252 \331\206\330\254\330\247\330\255\330\247 \331"
	"\207\331\210 \302\273\330\250\330\247\331\206\331\203\331\210\330\263"
	"\331\210\331\204\302\253 \331\201\331\212 \330\250\331\210\331\204"
	"\331\212\331\201\331\212\330\247.\n\n";
  buffer->insert_with_tags_by_name(iter,s,-1,({ "rtl_quote" }) );
  ta=allocate(5);
  for (int i=0; i<5; i++)
    ta[i]=buffer->create_child_anchor(iter);
  object button=GTK.Button("test");
  button->signal_connect("clicked",lambda() { write("foo\n"); },0);
  
  [object start,object end]=buffer->get_bounds();
  buffer->apply_tag_by_name("word_wrap",start,end);
}

int main(int argc, array argv) {
  GTK.setup_gtk(argv);
  object w=GTK.Window(GTK.WINDOW_TOPLEVEL);
  object sw=GTK.ScrolledWindow();
  object tv=GTK.TextView();
  object buffer=tv->get_buffer();
//  object font_desc=GTK.PangoFontDescription("Luxi Sans 12");
//  tv->modify_font(font_desc);
//  buffer->set_text("Hello, this is some text",-1);
//  tv->modify_text(0,GDK.Color(200,25,0));
//  tv->set_left_margin(30);
//  object tag=buffer->create_tag("blue_foreground","foreground","blue");
//  object start=buffer->get_iter_at_offset(7);
//  object end=buffer->get_iter_at_offset(12);
//  write("start==end==%d\n",start==end);
//  write("start==end==%d\n",start->equal(end));
//  write("start offset==%d  end offset==%d\n",start->get_offset(),end->get_offset());
//  write("start line==%d  end line==%d\n",start->get_line(),end->get_line());
//  write("start char==%c  end char==%c\n",start->get_char(),end->get_char());
//  write("start==%O  end==%O\n",start,end);
//  write("start==end==%d\n",start==end);
//  buffer->apply_tag(tag,start,end);
  sw->add(tv);
  w->add(sw);
  w->show_all();
  tv->set_size_request(300,300);
  create_tags(buffer);
  insert_text(buffer);
  object b=GTK.Button("click me");
  b->signal_connect("clicked",lambda() { write("foo\n"); },0);
  b->show_all();
  tv->add_child_at_anchor(b,ta[0]);
  w->signal_connect("destroy",lambda() { exit(0); },0);
  return -1;
}

