#!/usr/bin/env pike

void fixed_toggled(object w, array data, object ts) {
  GTK.TreePath path=GTK.TreePath(data[0]);
//  write("path==%O\n",path);
  GTK.TreeIter iter=ts->get_iter(path);
  int val=ts->get_value(iter,3);
//  write("val==%d\n",val);
  val=!val;
  ts->set_value(iter,3,val);
}

int main(int argc, array argv) {
  GTK.setup_gtk();
  object w=GTK.Window(GTK.WINDOW_TOPLEVEL);
  object vb=GTK.Vbox(0,8)->set_border_width(8);
  w->add(vb);
  vb->pack_start(GTK.Label("Jonathan's Holiday Card Planning Sheet"),0,0,0);
  object sw=GTK.ScrolledWindow();
  sw->set_shadow_type(GTK.SHADOW_ETCHED_IN)
	->set_policy(GTK.POLICY_AUTOMATIC,GTK.POLICY_AUTOMATIC);
  vb->pack_start(sw,1,1,0);
  
  GTK.TreeStore ts=GTK.TreeStore(({ "string","int","int","boolean","string" }) );
  object iter=ts->append();
  ts->set_row(iter,({ "foo",1,2,0,GTK.STOCK_OPEN }) );
  iter=ts->append();
  ts->set_row(iter,({ "bar",3,47,1,GTK.STOCK_CLOSE }) );
  iter=ts->append();
  ts->set_row(iter,({ "baz",124,97,0,GTK.STOCK_DELETE }) );
  GTK.TreeView tree=GTK.TreeView(ts);
  GTK.CellRenderer gcr=GTK.CellRendererText();
  array(GTK.TreeViewColumn) cols;
  cols=allocate(5);
//  write("gcr==%O\n",gcr);
//  write("family==%s\n",gcr->get_property("family"));
/*
  cols[0]=GTK.TreeViewColumn()->set_title("Name")
	->pack_start(gcr,1)
	->add_attribute(gcr,"text",0);
*/
  cols[0]=GTK.TreeViewColumn("Name",gcr,"text",0);
  gcr=GTK.CellRendererText();
  cols[1]=GTK.TreeViewColumn("Val 1",gcr,"text",1);
  gcr=GTK.CellRendererText();
  cols[2]=GTK.TreeViewColumn("Val 2",gcr,"text",2);
  gcr=GTK.CellRendererToggle();
  cols[3]=GTK.TreeViewColumn("Active?",gcr,"active",3);
  gcr->signal_connect("toggled",fixed_toggled,ts);
  gcr=GTK.CellRendererPixbuf();
  cols[4]=GTK.TreeViewColumn("Pic",gcr,"stock-id",4);
  tree->append_column(cols[0])
	->append_column(cols[1])
	->append_column(cols[2])
	->append_column(cols[3])
	->append_column(cols[4]);
  vb->add(tree);
  w->signal_connect("destroy",lambda() { exit(0); },0);
  w->show_all();
  return -1;
}

